import 'dart:async';
import 'dart:convert';
import 'dart:io';

import 'package:businesslibrary/api/data_api.dart';
import 'package:businesslibrary/data/govt_entity.dart';

class ListAPI {
  static HttpClient httpClient = new HttpClient();

  static Future<List<GovtEntity>> getGovtEntities() async {
    var url = DataAPI.getURL();
    print('NetworkAPI.getGovtEntities -----> url: $url');
    HttpClientRequest mRequest = await httpClient.getUrl(Uri.parse(url));
    HttpClientResponse resp = await mRequest.close();
    print('NetworkAPI.getGovtEntities ######### resp.statusCode: ${resp
            .statusCode}');
    var list = List<GovtEntity>();
    if (resp.statusCode == 200) {
      var contents = await _transform(resp);
      List mList = json.decode(contents);
      await mList.forEach((f) {
        GovtEntity g = new GovtEntity.fromJson(f);
        list.add(g);
        print('NetworkAPI.getGovtEntities)))))))  entity added to list: ${g
                .toJson()}');
      });

      print('NetworkAPI.getGovtEntities entities: ${list.length}');
      return list;
    } else {
      print('NetworkAPI.getGovtEntities ERROR  ${resp.reasonPhrase}');
      return null;
    }
  }

  static Future<String> _transform(HttpClientResponse resp) async {
    StringBuffer builder = new StringBuffer();
    await for (String a in await resp.transform(utf8.decoder)) {
      builder.write(a);
    }
    return builder.toString();
  }
}
